import { isLocationChildrenDetail } from '@gant-lowcode/lowcode-utils';
var IndentSensitive = 13;
export var IndentTrack = /*#__PURE__*/function () {
  function IndentTrack() {
    // 记录缩进起始坐标
    this.indentStart = null;
  }
  var _proto = IndentTrack.prototype;
  _proto.reset = function reset() {
    this.indentStart = null;
  }

  // 判断缩进方向并计算目标父节点
  ;
  _proto.getIndentParent = function getIndentParent(lastLoc, loc) {
    // 有效性校验（相同目标/相同源/相同索引）
    if (lastLoc.target !== loc.target || !isLocationChildrenDetail(lastLoc.detail) || !isLocationChildrenDetail(loc.detail) || lastLoc.source !== loc.source || lastLoc.detail.index !== loc.detail.index || loc.detail.index == null) {
      this.indentStart = null;
      return null;
    }
    if (this.indentStart == null) {
      this.indentStart = lastLoc.event.globalX;
    }
    // 计算水平移动距离
    var delta = loc.event.globalX - this.indentStart;
    var indent = Math.floor(Math.abs(delta) / IndentSensitive); // 15px/级

    if (indent < 1) {
      return null;
    }
    this.indentStart = loc.event.globalX;
    var direction = delta < 0 ? 'left' : 'right';
    var parent = loc.target;
    var index = loc.detail.index;

    // 方向判断与层级处理
    if (direction === 'left') {
      var _parent$children;
      if (!parent.parent || index < (((_parent$children = parent.children) === null || _parent$children === void 0 ? void 0 : _parent$children.size) || 0) || parent.isSlotNode) {
        return null;
      }
      return [parent.parent, parent.index + 1];
    } else {
      var _parent$children2;
      // 右移：降级为子节点
      if (index === 0) {
        return null;
      }
      parent = (_parent$children2 = parent.children) === null || _parent$children2 === void 0 ? void 0 : _parent$children2.get(index - 1);
      if (parent && parent.isContainerNode) {
        var _parent$children3;
        return [parent, (_parent$children3 = parent.children) === null || _parent$children3 === void 0 ? void 0 : _parent$children3.size];
      }
    }
    return null;
  };
  return IndentTrack;
}();